# SoMemoryError Class Reference
[Error handling]

`#include <Inventor/errors/SoMemoryError.h>`

Inheritance diagram for SoMemoryError:

List of all members.

## Detailed Description

The SoMemoryError class is used to inform of problems with memory allocation.

Modern operating systems takes care of handling most out of memory conditions for you, but in certain situations it can be wise to do some manual checking and intervention. This class is provided as an aid to help out in these situations.

The basic design of the Coin library is to pass on the responsibility for handling failed attempts at memory allocation to the application programmer. If you want to detect and take care of these, you should compile Coin with the C++ exception throwing on and wrap your code within `try{}` and `catch{}` blocks. The most you can do if you get a failed allocation is typically to notify the user and then exit the application, though, and this is something most operating systems will do for you, so you probably need not consider this at all.

So, where does the SoMemoryError class come in handy? There are certain things which could happen within the library which are best taken care of by internally handling failed attempts at memory allocation. An example: the user tries to load a model file which contains a filename pointer to a huge bitmapfile with a texture map. The end-user's system does not provide enough memory to load the file and prepare the texture image for rendering, though. This is a case where it is possible to just emit a warning and continue. The warning will then be passed through this class.

Note that SoMemoryError is probably not of much use to the application programmer.

## Public Member Functions

virtual SoType | getTypeId (void) const

## Static Public Member Functions

void | setHandlerCallback (SoErrorCB *const callback, void *const data)
SoErrorCB * | getHandlerCallback (void)
void * | getHandlerData (void)
SoType | getClassTypeId (void)
void | post (const char *const whatWasAllocated)
void | initClass (void)

## Protected Member Functions

virtual SoErrorCB * | getHandler (void *&data) const

## Member Function Documentation

void SoMemoryError::setHandlerCallback | ( | SoErrorCB *const | function,
|  | void *const | data
| ) | `[static]`

This method sets the error handler callback for messages posted via this class.

Note that this will not override the error/debug message handler for subclasses, these will have to be overrided by calling the subclass' setHandlerCallback() method.

See also:
  defaultHandlerCB()

Reimplemented from SoError.

SoErrorCB * SoMemoryError::getHandlerCallback | ( | void |  | ) | `[static]`

| Returns the error handler callback for messages posted via this class. Reimplemented from SoError.

void * SoMemoryError::getHandlerData | ( | void |  | ) | `[static]`

| This method returns the pointer used for passing data back to the callback handler method. Reimplemented from SoError.

SoType SoMemoryError::getClassTypeId | ( | void |  | ) | `[static]`

This static method returns the SoType for this class.

See also:
  getTypeId()

Reimplemented from SoError.

SoType SoMemoryError::getTypeId | ( | void |  | ) | const`[virtual]`

This method returns the SoType of a particular object instance.

See also:
  getClassTypeId()

Reimplemented from SoError.

void SoMemoryError::post | ( | const char *const | whatWasAllocated | ) | `[static]`

| Posts a warning about a failed memory allocation. whatWasAllocated should contain a description of what we tried to allocate.

void SoMemoryError::initClass | ( | void |  | ) | `[static]`

| This method takes care of initializing all static data for the class. Reimplemented from SoError.

SoErrorCB * SoMemoryError::getHandler | ( | void *& | data | ) | const`[protected, virtual]`

| This is just a convenience wrapper around the getHandlerCallback() and getHandlerData() methods. Reimplemented from SoError.

The documentation for this class was generated from the following files:

- SoMemoryError.h
- SoMemoryError.cpp